package de.snailshell.consensus.demo.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.snailshell.consensus.demo.Constants;
import de.uka.ipd.consensus.foundation.ontology.OntologyManager;

/**
 * @author Thomas Much
 * @version 2006-06-14
 */
public class ReorgAction extends BasisAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		if (!isUserLoggedOn(request)) {
			return mapping.findForward( Constants.MAPPING_FAILURE );			
		}

		if (!getUser(request).isAdmin()) {
			return mapping.findForward( Constants.MAPPING_FAILURE );			
		}
		
		OntologyManager om = this.getOntologyManager();
		
		boolean neu = om.reorg();
		
		if (neu) {
			request.setAttribute( Constants.REQUEST_ATTR_MESSAGE, "... WURDE NEU GESTARTET." );
		}
		else {
			request.setAttribute( Constants.REQUEST_ATTR_MESSAGE, "... L&Auml;UFT NOCH ..." );
		}

		return mapping.findForward( Constants.MAPPING_SUCCESS );
	}
}
